<template>
  <expansion-panel-to-create>
    <v-form
      ref="form"
      @submit.prevent
    >
      <v-container fluid>
        <v-row>
          <v-col cols="3">
            <date-picker-single-field
              v-model="form.referenceMonth"
              dense
              required
              type-month
              :min="periodStartDate"
              :max="periodEndDate"
              :label="$t('referenceMonth', { required: '*' })"
            />
          </v-col>
          <v-col cols="3">
            <money-text-field
              v-model="form.money"
              dense
              required
            />
          </v-col>
          <v-col cols="3">
            <date-picker-single-field
              v-model="form.dueDate"
              dense
              :min="periodStartDate"
              :max="periodEndDate"
              :label="$t('dueDate')"
            />
          </v-col>
          <v-col cols="3">
            <div class="d-flex justify-center">
              <cancel-btn
                class="mr-2"
                @click="onReset"
              >
                {{ $t('reset') }}
              </cancel-btn>
              <confirm-btn
                :loading="isLoading"
                @click="onSave"
              />
            </div>
          </v-col>
        </v-row>
      </v-container>
    </v-form>
  </expansion-panel-to-create>
</template>

<script>
  const getFormInitialState = () => {
    return {
      money: null,
      dueDate: null,
      referenceMonth: null,
    }
  }

  export default {
    name: 'AddAmount',
    props: {
      incomeId: {
        type: Number,
        required: true,
      },
    },
    data () {
      return {
        isLoading: false,
        form: getFormInitialState(),
      }
    },
    computed: {
      selectedPeriod () {
        return this.$store.getters['periods/getSelectedPeriod']
      },
      periodStartDate () {
        return this.selectedPeriod.startDate
      },
      periodEndDate () {
        return this.selectedPeriod.endDate
      },
    },
    methods: {
      onSave () {
        if (this.$refs.form.validate()) {
          this.isLoading = true
          const { money, dueDate, referenceMonth } = this.form
          this.$store.dispatch('incomeAmounts/createIncomeAmount', {
            incomeId: this.incomeId,
            referenceMonth,
            amount: money,
            dueDate,
          })
            .then(() => {
              this.onReset()
            })
            .finally(() => {
              this.isLoading = false
            })
        }
      },
      onReset () {
        this.$refs.form.reset()
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          dueDate: 'Data de vencimento',
          referenceMonth: 'Mês de referência{required}',
          reset: 'Resetar',
        },
        'en-US': {
          dueDate: 'Due date',
          referenceMonth: 'Reference month{required}',
          reset: 'Reset',
        },
      },
    },
  }
</script>
